create or replace procedure P_YPMODIFY_ECONOPRS_OPRSPECS
( /* */
  nIdent           in number,
  nCOMPANY         in number,
  sJUR_PERS        in varchar2, --  
  sOPER_PREF       in varchar2, -- 
  sOPER_CONTENTS   in varchar2, -- 
  dOPER_DATE       in date,     --  
  sSPECIAL_MARK    in varchar2, --  
  sVDOC_TYPE       in varchar2, --  -
  sVDOC_NUMB       in varchar2, --  -
  dVDOC_DATE       in date,     --  -
  sFDOC_TYPE       in varchar2, --  -
  sFDOC_NUMB       in varchar2, --  -
  dFDOC_DATE       in date,     --  -
  sESCORT_DOCTYPE  in varchar2, --  -
  sEscort_docnumb  in varchar2, --  -
  dESCORT_DOCDATE  in date,     --   
  sAGENT_FROM      in varchar2, -- 
  sAGENT_TO        in varchar2, -- 
  /* */
  sACC_DEBIT       in varchar2, -- 
  sANL1_DEBIT      in varchar2, -- 1   
  sANL2_DEBIT      in varchar2, -- 2   
  sANL3_DEBIT      in varchar2, -- 3   
  sANL4_DEBIT      in varchar2, -- 4   
  sANL5_DEBIT      in varchar2, -- 5   
  sACC_CREDIT      in varchar2, -- 
  sANL1_CREDIT     in varchar2, -- 1   
  sANL2_CREDIT     in varchar2, -- 2   
  sANL3_CREDIT     in varchar2, -- 3   
  sANL4_CREDIT     in varchar2, -- 4   
  sANL5_CREDIT     in varchar2, -- 5   
  ORDER_NUMB       in varchar2, --  
  sNOMENCLATURE    in varchar2, -- 
  sNOMEN_PARTNO    in varchar2, --  
  /*  */
  sFJUR_PERS       in varchar2,  --   
  sFAGENT_FROM      in varchar2, --  
  sFAGENT_TO        in varchar2, --  
  sFNOMENCLATURE    in varchar2, --  
  sORDER_NUMB       in varchar2, --   
  sFACC_DEBIT       in varchar2, --   
  sFANL1_DEBIT      in varchar2, --   1   
  sFANL2_DEBIT      in varchar2, --   2   
  sFANL3_DEBIT      in varchar2, --   3   
  sFANL4_DEBIT      in varchar2, --   4   
  sFANL5_DEBIT      in varchar2, --   5   
  sFACC_CREDIT      in varchar2, --   
  sFANL1_CREDIT     in varchar2, --   1   
  sFANL2_CREDIT     in varchar2, --   2   
  sFANL3_CREDIT     in varchar2, --   3   
  sFANL4_CREDIT     in varchar2, --   4   
  sFANL5_CREDIT     in varchar2, --   5   
  nCheck            in number    --   
)
as
  nCount           number;
  newRN            number(17);
  newRNSpec        number(17);
  econrow          v_econoprs%rowtype;
  specsrow         v_oprspecs%rowtype;
  sMark            varchar2(2) :='()';
  sSQL             varchar2(4000);
  sSQLS            varchar2(4000);
  curecon          PKG_CURSORS.CurType;
  curspecs         PKG_CURSORS.CurType;
  sAccount         DICACCS.ACC_NUMBER%type;
  sAnl             DICANLS.ANL_NUMBER%type;
  nFIND_IN         PKG_STD.tREF;
  nFIND_OUT        PKG_STD.tREF;

begin
  /*   */
  if  sJUR_PERS  is  null and
      sOPER_PREF  is  null and
      sOPER_CONTENTS  is  null and
      dOPER_DATE is  null and
      sSPECIAL_MARK  is  null and
      sVDOC_TYPE  is  null and
      sVDOC_NUMB  is  null and
      dVDOC_DATE  is  null and
      sFDOC_TYPE  is  null and
      sFDOC_NUMB  is  null and
      dFDOC_DATE  is  null and
      sESCORT_DOCTYPE  is  null and
      sEscort_docnumb  is  null and
      dESCORT_DOCDATE  is  null and
      sAGENT_FROM   is  null and
      sAGENT_TO is  null and
      sACC_DEBIT  is  null and
      sANL1_DEBIT is  null and
      sANL2_DEBIT is  null and
      sANL3_DEBIT is  null and
      sANL4_DEBIT is  null and
      sANL5_DEBIT is  null and
      sACC_CREDIT is  null and
      sANL1_CREDIT is  null and
      sANL2_CREDIT is  null and
      sANL3_CREDIT is  null and
      sANL4_CREDIT is  null and
      sANL5_CREDIT is  null and
      ORDER_NUMB    is  null and
      sNOMENCLATURE is  null and
      sNOMEN_PARTNO is  null  then p_exception(0,'    ');
   end if;

  /*   V_ECONOPRS*/
  sSQL:='select e.rn,'||CR
             ||'e.Company, '||CR
             ||'e.crn, '||CR
             ||'e.sjur_pers, '||CR
             ||'e.operation_pref, '||CR
             ||'e.operation_numb, '||CR
             ||'e.operation_contents, '||CR
             ||'e.operation_date, '||CR
             ||'e.special_mark, '||CR
             ||'e.valid_doctype, '||CR
             ||'e.valid_docnumb, '||CR
             ||'e.valid_docdate, '||CR
             ||'e.fact_doctype, '||CR
             ||'e.fact_docnumb, '||CR
             ||'e.fact_docdate, '||CR
             ||'e.agent_from, '||CR
             ||'e.agent_to, '||CR
             ||'e.sescort_doctype, '||CR
             ||'e.sescort_docnumb, '||CR
             ||'e.descort_docdate '||CR
        ||'from SELECTLIST  SL, '||CR
             ||'V_ECONOPRS  E '||CR
       ||'where SL.IDENT =  '||nIDENT||CR
         ||'and E.RN = SL.DOCUMENT '||CR;
  /*  */
  if sFJUR_PERS is not null then
     sSQL := sSQL||'and E.sjur_pers = '||chr(39)||sFJUR_PERS||chr(39)||CR;
  end if;
  /*    " "*/
  if sFAGENT_FROM is not null then
     sSQL :=  sSQL||'and E.agent_from = '||chr(39)||sFAGENT_FROM||chr(39)||CR;
  end if;
  /*    ""*/
  if sFAGENT_TO is not null then
     sSQL :=  sSQL||'and E.agent_to = '||chr(39)||sFAGENT_TO||chr(39)||CR;
  end if;
 /*    */
  if sFACC_DEBIT is not null then
     sAccount:=replace(sFACC_DEBIT,'*','%');
     sAccount:=replace(sAccount,'?','_');---101343
     sSQL:=sSQL||'and exists (select null '||CR
               ||'   from v_oprspecs o '||CR
               ||'  where o.prn = e.rn '||CR
               ||'    and o.account_debit like '||chr(39)||sAccount||chr(39);
     if sFANL1_DEBIT is not null then /*   1   */
        sAnl:=replace(sFANL1_DEBIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_debit1 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL2_DEBIT is not null then/*   2   */
        sAnl:=replace(sFANL2_DEBIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_debit2 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL3_DEBIT is not null then/*   3   */
        sAnl:=replace(sFANL3_DEBIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_debit3 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL4_DEBIT is not null then/*   4   */
        sAnl:=replace(sFANL4_DEBIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_debit4 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL5_DEBIT is not null then/*   5   */
        sAnl:=replace(sFANL5_DEBIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_debit5 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     sSQL:=sSQL||')'||CR;
  end if;
  /*    */
  if sFACC_CREDIT is not null then
     sAccount:=replace(sFACC_CREDIT,'*','%');
     sAccount:=replace(sAccount,'?','_');---101343
     sSQL:=sSQL||'and exists (select null '||CR
               ||'  from v_oprspecs o '||CR
               ||'  where o.prn = e.rn '||CR
               ||'    and o.account_credit like '||chr(39)||sAccount||chr(39);
     if sFANL1_CREDIT is not null then /*   1   */
        sAnl:=replace(sFANL1_CREDIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_credit1 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL2_CREDIT is not null then /*   2   */
        sAnl:=replace(sFANL2_CREDIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_credit2 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL3_CREDIT is not null then /*   3   */
        sAnl:=replace(sFANL3_CREDIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_credit3 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL4_CREDIT is not null then /*   4   */
        sAnl:=replace(sFANL4_CREDIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_credit4 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     if sFANL5_CREDIT is not null then /*   5   */
        sAnl:=replace(sFANL5_CREDIT,'*','%');
        sAnl:=replace(sAnl,'?','_');---101343
        sSQL:=sSQL||' and o.analytic_credit5 like '||chr(39)||sAnl||chr(39)||CR;
     end if;
     sSQL:=sSQL||')'||CR;
  end if;
  /*  */
  if sFNOMENCLATURE is not null then
     sSQL:=sSQL||'and exists (select null '||CR
               ||'   from v_oprspecs o '||CR
               ||'  where o.prn = e.rn '||CR
               ||'    and o.nomen_code = '||chr(39)||sFNOMENCLATURE||chr(39)||')'||CR;
  end if;
  /*    */
  if sORDER_NUMB is not null then
     sSQL:=sSQL||'and exists (select null '||CR
               ||'   from v_oprspecs o '||CR
               ||'  where o.prn = e.rn '||CR
               ||'    and o.order_numb = '||chr(39)||sORDER_NUMB||chr(39)||')'||CR;
  end if;
  --p_exception(0, sSQL);
  open curecon for sSQL;
  loop
    fetch curecon into econrow.rn,
                       econrow.Company,
                       econrow.crn,
                       econrow.sjur_pers,
                       econrow.operation_pref,
                       econrow.operation_numb,
                       econrow.operation_contents,
                       econrow.operation_date,
                       econrow.special_mark,
                       econrow.valid_doctype,
                       econrow.valid_docnumb,
                       econrow.valid_docdate,
                       econrow.fact_doctype,
                       econrow.fact_docnumb,
                       econrow.fact_docdate,
                       econrow.agent_from,
                       econrow.agent_to,
                       econrow.sescort_doctype,
                       econrow.sescort_docnumb,
                       econrow.descort_docdate;
   exit when curecon%notfound;
   /*   update */
   /**/
   if sJUR_PERS  is not null then econrow.sjur_pers := sJUR_PERS;end if;
   /**/
   if sOPER_PREF is not null then econrow.operation_pref := sOPER_PREF;end if;
   /*  */
   if dOPER_DATE is not null then econrow.operation_date := dOPER_DATE;end if;
   /*  */
   if sOPER_CONTENTS is not null then  econrow.operation_contents := sOPER_CONTENTS; end if;
   /* */
   if sSPECIAL_MARK is not null then  econrow.special_mark := sSPECIAL_MARK; end if;
   /* -*/
   if sVDOC_TYPE is not null and sVDOC_TYPE <> sMark then  econrow.valid_doctype := sVDOC_TYPE;
    elsif sVDOC_TYPE = sMark then econrow.valid_doctype :=null;
   end if;
   /*  -*/
   if sVDOC_NUMB is not null and sVDOC_NUMB <> sMark then econrow.valid_docnumb := sVDOC_NUMB;
    elsif sVDOC_NUMB = sMark then econrow.valid_docnumb :=null;
   end if;
   /* -*/
   if dVDOC_DATE is not null then econrow.valid_docdate := dVDOC_DATE;
    elsif dVDOC_DATE is null and  sVDOC_TYPE = sMark and sVDOC_NUMB = sMark then econrow.valid_docdate := null;
   end if;
   /* -*/
   if sFDOC_TYPE is not null and sFDOC_TYPE<>sMark then econrow.fact_doctype := sFDOC_TYPE;
    elsif sFDOC_TYPE = sMark then econrow.fact_doctype :=null;
   end if;
    /* -*/
   if sFDOC_NUMB is not null and sFDOC_NUMB<>sMark then econrow.fact_docnumb := sFDOC_NUMB;
    elsif sFDOC_NUMB = sMark then econrow.fact_docnumb :=null;
   end if;
   /* -*/
   if dFDOC_DATE is not null then  econrow.fact_docdate := dFDOC_DATE;
     elsif  dFDOC_DATE is null and sFDOC_NUMB = sMark and sFDOC_TYPE = sMark then econrow.fact_docdate := null;
   end if;
   /* -*/
   if sESCORT_DOCTYPE is not null and sESCORT_DOCTYPE<>sMark then econrow.sescort_doctype := sESCORT_DOCTYPE;
    elsif sESCORT_DOCTYPE = sMark then econrow.sescort_doctype :=null;
   end if;
   /* -*/
   if sEscort_docnumb is not null and sEscort_docnumb<>sMark then econrow.sescort_docnumb := sEscort_docnumb;
    elsif sEscort_docnumb = sMark then econrow.sescort_docnumb :=null;
   end if;
   /* -*/
   if dESCORT_DOCDATE is not null then econrow.descort_docdate := dESCORT_DOCDATE;
    elsif  sESCORT_DOCTYPE=sMark and sEscort_docnumb=sMark and dESCORT_DOCDATE is null then econrow.descort_docdate:=null;
   end if;
   /*  */
   if sAGENT_FROM is not null and sAGENT_FROM <> sMark  then econrow.agent_from := sagent_from;
    elsif sAGENT_FROM = sMark then econrow.agent_from :=null;
   end if;
   /* */
   if sAGENT_TO is not null and sAGENT_TO <> sMark then econrow.AGENT_TO := sAGENT_TO;
    elsif sAGENT_TO = sMark then econrow.AGENT_TO :=null;
   end if;
   if nCheck = 1 then
     /*     DOCLINKS*/
     begin
       select count(*)
         into nCount
         from DOCLINKS d
        where D.Out_Unitcode='EconomicOperations'
          and D.Out_Document= econrow.rn;
    exception
         when others then
              nCount:=1;
     end;
     /*    */
     P_DOCINPT_FIND_EXACT( 1,nCOMPANY,'EconomicOperations',econrow.rn,nFIND_IN );
     /*    */
     P_DOCOUTPT_FIND_EXACT( 1,nCOMPANY,'EconomicOperations',econrow.rn,nFIND_OUT );
     /*  */
     if ( nFIND_IN is  null and nFIND_OUT  is null ) then  null;
     else  /* */
       if nCount>0 then
          P_ECONOPRS_SMART_LINK(econrow.rn,nCOMPANY);
       end if;
     end if;
   end if;
   /*  */
   MODIFY_ECONOPRS(econrow.rn,
                   econrow.Company,
                   econrow.crn,
                   econrow.sjur_pers,
                   econrow.operation_pref,
                   econrow.operation_numb,
                   econrow.operation_contents,
                   econrow.operation_date,
                   econrow.special_mark,
                   econrow.valid_doctype,
                   econrow.valid_docnumb,
                   econrow.valid_docdate,
                   econrow.fact_doctype,
                   econrow.fact_docnumb,
                   econrow.fact_docdate,
                   econrow.agent_from,
                   econrow.agent_to,
                   econrow.sescort_doctype,
                   econrow.sescort_docnumb,
                   econrow.descort_docdate,
                   newRN);

   /*   */
   if sACC_DEBIT  is  null and
      sANL1_DEBIT is  null and
      sANL2_DEBIT is  null and
      sANL3_DEBIT is  null and
      sANL4_DEBIT is  null and
      sANL5_DEBIT is  null and
      sACC_CREDIT is  null and
      sANL1_CREDIT is  null and
      sANL2_CREDIT is  null and
      sANL3_CREDIT is  null and
      sANL4_CREDIT is  null and
      sANL5_CREDIT is  null and
      ORDER_NUMB    is  null and
      sNOMENCLATURE is  null and
      sNOMEN_PARTNO is  null  then null;

   else
       /*  */
       sSQLS:=' select o.rn, '||CR
                  ||'  o.company, '||CR
                  ||'  o.prn, '||CR
                  ||'  o.balunit_debit, '||CR
                  ||'  o.account_debit, '||CR
                  ||'  o.analytic_debit1, '||CR
                  ||'  o.analytic_debit2, '||CR
                  ||'  o.analytic_debit3, '||CR
                  ||'  o.analytic_debit4, '||CR
                  ||'  o.analytic_debit5, '||CR
                  ||'  o.balunit_credit, '||CR
                  ||'  o.account_credit, '||CR
                  ||'  o.analytic_credit1, '||CR
                  ||'  o.analytic_credit2, '||CR
                  ||'  o.analytic_credit3, '||CR
                  ||'  o.analytic_credit4, '||CR
                  ||'  o.analytic_credit5, '||CR
                  ||'  o.currency, '||CR
                  ||'  o.nomen_code, '||CR
                  ||'  o.nomen_partno, '||CR
                  ||'  o.nomen_indate, '||CR
                  ||'  o.acnt_sum, '||CR
                  ||'  o.acnt_base_sum, '||CR
                  ||'  o.ACNT_QUANT, '||CR
                  ||'  o.ACNT_ALT_QUANT, '||CR
                  ||'  o.ACNT_EQUAL, '||CR
                  ||'  o.CTRL_SUM, '||CR
                  ||'  o.CTRL_BASE_SUM, '||CR
                  ||'  o.CTRL_QUANT, '||CR
                  ||'  o.CTRL_ALT_QUANT,  '||CR
                  ||'  o.CTRL_EQUAL,  '||CR
                  ||'  o.order_numb,  '||CR
                  ||'  o.record_type,  '||CR
                  ||'  o.nacnt_acctypes_sum,  '||CR
                  ||'  o.nctrl_acctypes_sum  '||CR
              ||' from v_oprspecs o  '||CR
             ||' where o.prn = '||econrow.rn;
     /*    */
      if sFACC_DEBIT is not null then
         sAccount:=replace(sFACC_DEBIT,'*','%');
         sAccount:=replace(sAccount,'?','_');---101343
         sSQLS:=sSQLS||' and o.account_debit like '||chr(39)||sAccount||chr(39);
      end if;
      if sFANL1_DEBIT is not null then /*   1   */
         sAnl:=replace(sFANL1_DEBIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_debit1 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL2_DEBIT is not null then/*   2   */
         sAnl:=replace(sFANL2_DEBIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_debit2 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL3_DEBIT is not null then/*   3   */
         sAnl:=replace(sFANL3_DEBIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_debit3 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL4_DEBIT is not null then/*   4   */
         sAnl:=replace(sFANL4_DEBIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_debit4 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL5_DEBIT is not null then/*   5   */
         sAnl:=replace(sFANL5_DEBIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_debit5 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      /*    */
      if sFACC_CREDIT is not null then
         sAccount:=replace(sFACC_CREDIT,'*','%');
         sAccount:=replace(sAccount,'?','_');---101343
         sSQLS:=sSQLS||' and o.account_credit like '||chr(39)||sAccount||chr(39);
      end if;
      if sFANL1_CREDIT is not null then /*   1   */
         sAnl:=replace(sFANL1_CREDIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_credit1 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL2_CREDIT is not null then /*   2   */
         sAnl:=replace(sFANL2_CREDIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_credit2 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL3_CREDIT is not null then /*   3   */
         sAnl:=replace(sFANL3_CREDIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_credit3 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL4_CREDIT is not null then /*   4   */
         sAnl:=replace(sFANL4_CREDIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_credit4 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      if sFANL5_CREDIT is not null then /*   5   */
         sAnl:=replace(sFANL5_CREDIT,'*','%');
         sAnl:=replace(sAnl,'?','_');---101343
         sSQLS:=sSQLS||' and o.analytic_credit5 like '||chr(39)||sAnl||chr(39)||CR;
      end if;
      /*  */
      if sFNOMENCLATURE is not null then
         sSQLS:=sSQLS||' and o.nomen_code = '||chr(39)||sFNOMENCLATURE||chr(39)||CR;
      end if;
      /*    */
      if sORDER_NUMB is not null then
         sSQLS:=sSQLS||' and o.order_numb = '||chr(39)||sORDER_NUMB||chr(39)||CR;
      end if;
      /*   */
      --p_exception(0,ssqls);
      open curspecs for sSQLS;
        loop
          fetch curspecs into specsrow.rn,
                              specsrow.company,
                              specsrow.prn,
                              specsrow.balunit_debit,
                              specsrow.account_debit,
                              specsrow.analytic_debit1,
                              specsrow.analytic_debit2,
                              specsrow.analytic_debit3,
                              specsrow.analytic_debit4,
                              specsrow.analytic_debit5,
                              specsrow.balunit_credit,
                              specsrow.account_credit,
                              specsrow.analytic_credit1,
                              specsrow.analytic_credit2,
                              specsrow.analytic_credit3,
                              specsrow.analytic_credit4,
                              specsrow.analytic_credit5,
                              specsrow.currency,
                              specsrow.nomen_code,
                              specsrow.nomen_partno,
                              specsrow.nomen_indate,
                              specsrow.acnt_sum,
                              specsrow.acnt_base_sum,
                              specsrow.ACNT_QUANT,
                              specsrow.ACNT_ALT_QUANT,
                              specsrow.ACNT_EQUAL,
                              specsrow.CTRL_SUM,
                              specsrow.CTRL_BASE_SUM,
                              specsrow.CTRL_QUANT,
                              specsrow.CTRL_ALT_QUANT,
                              specsrow.CTRL_EQUAL,
                              specsrow.order_numb,
                              specsrow.record_type,
                              specsrow.nacnt_acctypes_sum,
                              specsrow.nctrl_acctypes_sum;
        exit when curspecs%notfound;
        /*     */
        if sACC_DEBIT  is not null then specsrow.account_debit  :=trim(sACC_DEBIT);end if;       -- 
        if sANL1_DEBIT is not null and not sANL1_DEBIT = '()' then ---85139
          specsrow.analytic_debit1:=trim(sANL1_DEBIT);
        elsif sANL1_DEBIT = '()' then
          specsrow.analytic_debit1:=null;
        end if;     -- 1   
        if sANL2_DEBIT is not null and not sANL2_DEBIT = '()' then ---85139
          specsrow.analytic_debit2:=trim(sANL2_DEBIT);
        elsif sANL2_DEBIT = '()' then
          specsrow.analytic_debit2:=null;
        end if;     -- 2   
        if sANL3_DEBIT is not null and not sANL3_DEBIT = '()'  then ---85139
          specsrow.analytic_debit3:=trim(sANL3_DEBIT);
        elsif sANL3_DEBIT = '()' then
          specsrow.analytic_debit3:=null;
        end if;     -- 3   
        if sANL4_DEBIT is not null and not sANL4_DEBIT = '()'  then ---85139
          specsrow.analytic_debit4:=trim(sANL4_DEBIT);
        elsif sANL4_DEBIT = '()' then
          specsrow.analytic_debit4:=null;
        end if;     -- 4   
        if sANL5_DEBIT is not null and not sANL5_DEBIT = '()' then ---85262
          specsrow.analytic_debit5:=trim(sANL5_DEBIT);
        elsif sANL5_DEBIT = '()' then
          specsrow.analytic_debit5:=null;
        end if;     -- 5   
        if sACC_CREDIT is not null then specsrow.account_credit :=trim(sACC_CREDIT);end if;     -- 
        if sANL1_CREDIT is not null  and not sANL1_CREDIT = '()' then ---85139
          specsrow.analytic_credit1:= trim(sANL1_CREDIT);
        elsif sANL1_CREDIT = '()' then
          specsrow.analytic_credit1:=null;
        end if; -- 1   
        if sANL2_CREDIT is not null  and not sANL2_CREDIT = '()' then  ---85262
          specsrow.analytic_credit2:= trim(sANL2_CREDIT);
        elsif sANL2_CREDIT = '()' then
          specsrow.analytic_credit2:= null;
        end if; -- 2   
        if sANL3_CREDIT is not null  and not sANL3_CREDIT = '()' then  ---85262
          specsrow.analytic_credit3:= trim(sANL3_CREDIT);
        elsif sANL3_CREDIT = '()' then
          specsrow.analytic_credit3:= null;
        end if; -- 3   
        if sANL4_CREDIT is not null  and not sANL4_CREDIT = '()' then  ---85262
          specsrow.analytic_credit4:= trim(sANL4_CREDIT);
        elsif sANL4_CREDIT = '()' then
          specsrow.analytic_credit4:= null;
        end if; -- 4   
        if sANL5_CREDIT is not null and not sANL5_CREDIT = '()' then  ---85262
          specsrow.analytic_credit5:= trim(sANL5_CREDIT);
        elsif sANL5_CREDIT = '()' then
          specsrow.analytic_credit5:=null;
        end if; -- 5   
        if ORDER_NUMB is not null then specsrow.order_numb:=trim(ORDER_NUMB);end if;            --  
        if sNOMENCLATURE  is not null then specsrow.nomen_code:=trim(sNOMENCLATURE);end if;     -- 
        if sNOMEN_PARTNO  is not null then specsrow.nomen_partno:=trim(sNOMEN_PARTNO);end if;   --  
        /* */
        MODIFY_OPRSPECS(specsrow.rn,
                        specsrow.company,
                        specsrow.prn,
                        specsrow.balunit_debit,
                        specsrow.account_debit,
                        specsrow.analytic_debit1,
                        specsrow.analytic_debit2,
                        specsrow.analytic_debit3,
                        specsrow.analytic_debit4,
                        specsrow.analytic_debit5,
                        specsrow.balunit_credit,
                        specsrow.account_credit,
                        specsrow.analytic_credit1,
                        specsrow.analytic_credit2,
                        specsrow.analytic_credit3,
                        specsrow.analytic_credit4,
                        specsrow.analytic_credit5,
                        specsrow.currency,
                        specsrow.nomen_code,
                        specsrow.nomen_partno,
                        specsrow.nomen_indate,
                        specsrow.acnt_sum,
                        specsrow.acnt_base_sum,
                        specsrow.ACNT_QUANT,
                        specsrow.ACNT_ALT_QUANT,
                        specsrow.ACNT_EQUAL,
                        specsrow.CTRL_SUM,
                        specsrow.CTRL_BASE_SUM,
                        specsrow.CTRL_QUANT,
                        specsrow.CTRL_ALT_QUANT,
                        specsrow.CTRL_EQUAL,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        null,
                        specsrow.order_numb,
                        specsrow.record_type,
                        specsrow.nacnt_acctypes_sum,
                        specsrow.nctrl_acctypes_sum,
                        1,
                        newRNSpec);
    end loop;
    close curspecs;
   end if;
   if nCheck = 1 then
     /* */
     if nCount>0 then
        P_ECONOPRS_HARD_LINK (econrow.rn,nCOMPANY );
     end if;
   end if;
  end loop;
  close curecon;
end;
/
grant execute on P_YPMODIFY_ECONOPRS_OPRSPECS to public;